#include<bits/stdc++.h>
#define ll long long
#define pb push_back
#define ff first
#define ss second
#define mp make_pair
using namespace std;
int n,c,q,l,r,L[400005];
pair<int,int>stablo[400005],res;
string s;
void kreiraj(int cvor,int p,int k){
   if(p==k){
     if(s[p-1]=='0'){
        stablo[cvor].ff++;
     }
     else {
        stablo[cvor].ss++;
     }
   }
   else {
      int sr=p+(k-p)/2;
      kreiraj(2*cvor,p,sr);
      kreiraj(2*cvor+1,sr+1,k);
      stablo[cvor].ff=stablo[2*cvor].ff+stablo[2*cvor+1].ff;
      stablo[cvor].ss=stablo[2*cvor].ss+stablo[2*cvor+1].ss;
   }
}
void updatuj(int cvor,int p,int k,int l,int r){
   if(p>k or p>r or l>k){return;}
   if(L[cvor]!=0){
     swap(stablo[cvor].ff,stablo[cvor].ss);
     if(p!=k){
        L[cvor*2]+=L[cvor];
        L[cvor*2+1]+=L[cvor];
     }
     L[cvor]=0;
   }
   if(p>=l and k<=r){
     swap(stablo[cvor].ff,stablo[cvor].ss);
     if(p!=k){
        L[cvor*2]++;
        L[cvor*2+1]++;
     }
     return;
   }
   int sr=p+(k-p)/2;
   updatuj(2*cvor,p,sr,l,r);
   updatuj(2*cvor+1,sr+1,k,l,r);
   stablo[cvor].ff=stablo[2*cvor].ff+stablo[2*cvor+1].ff;
   stablo[cvor].ss=stablo[2*cvor].ss+stablo[2*cvor+1].ss;
}
pair<int,int> kveri(int cvor,int p,int k,int l,int r){
  if(r<p or l>k){return {0,0};}
  if(L[cvor]!=0){
    swap(stablo[cvor].ff,stablo[cvor].ss);
    if(p!=k){
        L[cvor*2]+=L[cvor];
        L[cvor*2+1]+=L[cvor];
    }
    L[cvor]=0;
  }
  if(l<=p and k<=r){
    return {stablo[cvor].ff,stablo[cvor].ss};
  }
  int sr=p+(k-p)/2;
  pair<int,int> a=kveri(2*cvor,p,sr,l,r);
  pair<int,int> b=kveri(2*cvor+1,sr+1,k,l,r);
  return {(a.ff+b.ff),(a.ss+b.ss)};
}
int main () {
cin.tie(NULL);
ios_base::sync_with_stdio(false);
cin>>n>>c>>q>>s;
kreiraj(1,1,n);
for(int i=1;i<=q;i++){
    cin>>l>>r;
    updatuj(1,1,n,l,r);
    res=kveri(1,1,n,1,n);
    if(c==n){
        cout<<res.ss<<endl;
    }
}
return 0;
}